wxWidgets: wxTextFile Class Reference

| Version: 3.0.5

Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
wxTextFile Class Reference
Class List by Category » File Handling

`#include </home/Hamis/wxwidgets/wxWidgets3.0/wxWidgets3.0-3.0.5.1-2.x86_64/src/wxWidgets-3.0.5.1/interface/wx/textfile.h>`

## Detailed Description

The wxTextFile is a simple class which allows working with text files on line by line basis.

It also understands the differences in line termination characters under different platforms and will not do anything bad to files with "non native" line termination sequences - in fact, it can be also used to modify the text files and change the line termination characters from one type (say DOS) to another (say Unix).

One word of warning: the class is not at all optimized for big files and thus it will load the file entirely into memory when opened. Of course, you should not work in this way with large files (as an estimation, anything over 1 Megabyte is surely too big for this class). On the other hand, it is not a serious limitation for small files like configuration files or program sources which are well handled by wxTextFile.

The typical things you may do with wxTextFile in order are:

- Create and open it: this is done with either wxTextFile::Create or wxTextFile::Open function which opens the file (name may be specified either as the argument to these functions or in the constructor), reads its contents in memory (in the case of wxTextFile::Open()) and closes it.
- Work with the lines in the file: this may be done either with "direct access" functions like wxTextFile::GetLineCount and wxTextFile::GetLine (operator[] does exactly the same but looks more like array addressing) or with "sequential access" functions which include wxTextFile::GetFirstLine, wxTextFile::GetNextLine and also wxTextFile::GetLastLine, wxTextFile::GetPrevLine. For the sequential access functions the current line number is maintained: it is returned by wxTextFile::GetCurrentLine and may be changed with wxTextFile::GoToLine.
- Add/remove lines to the file: wxTextFile::AddLine and wxTextFile::InsertLine add new lines while wxTextFile::RemoveLine deletes the existing ones. wxTextFile::Clear resets the file to empty.
- Save your changes: notice that the changes you make to the file will not be saved automatically; calling wxTextFile::Close or doing nothing discards them! To save the changes you must explicitly call wxTextFile::Write - here, you may also change the line termination type if you wish.

##

Library: wxBase

<>< =''>:</>&;&;< =''>\ </></>

See also
  wxFile

## Public Member Functions
| wxTextFile ()
| Default constructor, use Create() or Open() with a file name parameter to initialize the object. More...
| wxTextFile (const wxString &strFile)
| Constructor does not load the file into memory, use Open() to do it. More...
virtual | ~wxTextFile ()
| Destructor does nothing. More...
void | AddLine (const wxString &str, wxTextFileType type=typeDefault)
| Adds a line to the end of file. More...
void | Clear ()
| Delete all lines from the file, set current line number to 0. More...
bool | Close ()
| Closes the file and frees memory, "losing all changes". More...
bool | Create ()
| Creates the file with the name which was given in the wxTextFile(const wxString&) constructor. More...
bool | Create (const wxString &strFile)
| Creates the file with the given name. More...
bool | Eof () const
| Returns true if the current line is the last one. More...
bool | Exists () const
| Return true if file exists - the name of the file should have been specified in the constructor before calling Exists(). More...
size_t | GetCurrentLine () const
| Returns the current line: it has meaning only when you're using GetFirstLine()/GetNextLine() functions, it doesn't get updated when you're using "direct access" functions like GetLine(). More...
wxString & | GetFirstLine ()
| This method together with GetNextLine() allows more "iterator-like" traversal of the list of lines, i.e. More...
wxString & | GetLastLine ()
| Gets the last line of the file. More...
wxString & | GetLine (size_t n)
| Retrieves the line number n from the file. More...
const wxString & | GetLine (size_t n) const
size_t | GetLineCount () const
| Get the number of lines in the file. More...
wxTextFileType | GetLineType (size_t n) const
| Get the type of the line (see also wxTextFile::GetEOL). More...
const wxString & | GetName () const
| Get the name of the file. More...
wxString & | GetNextLine ()
| Gets the next line (see GetFirstLine() for the example). More...
wxString & | GetPrevLine ()
| Gets the previous line in the file. More...
void | GoToLine (size_t n)
| Changes the value returned by GetCurrentLine() and used by GetFirstLine() and GetNextLine(). More...
wxTextFileType | GuessType () const
| Guess the type of file (which is supposed to be opened). More...
void | InsertLine (const wxString &str, size_t n, wxTextFileType type=typeDefault)
| Insert a line before the line number n. More...
bool | IsOpened () const
| Returns true if the file is currently opened. More...
bool | Open (const wxMBConv &conv=wxConvAuto())
| Opens the file with the name which was given in the wxTextFile(const wxString&) constructor and also loads file in memory on success. More...
bool | Open (const wxString &strFile, const wxMBConv &conv=wxConvAuto())
| Opens the file with the given name and also loads file in memory on success. More...
void | RemoveLine (size_t n)
| Delete line number n from the file. More...
bool | Write (wxTextFileType typeNew=wxTextFileType_None, const wxMBConv &conv=wxConvAuto())
| Change the file on disk. More...
wxString & | operator[] (size_t n) const
| The same as GetLine(). More...

## Static Public Member Functions
static const wxChar * | GetEOL (wxTextFileType type=typeDefault)
| Get the line termination string corresponding to given constant. More...

## Static Public Attributes
static const wxTextFileType | typeDefault
| Default type for current platform determined at compile time. More...

## Constructor & Destructor Documentation

## ◆ wxTextFile() [1/2]

wxTextFile::wxTextFile | ( |  | ) |

Default constructor, use Create() or Open() with a file name parameter to initialize the object.

## ◆ wxTextFile() [2/2]

wxTextFile::wxTextFile | ( | const wxString & | strFile | ) |

Constructor does not load the file into memory, use Open() to do it.

## ◆ ~wxTextFile()

virtual wxTextFile::~wxTextFile | ( |  | ) |
| virtual

Destructor does nothing.

## Member Function Documentation

## ◆ AddLine()

void wxTextFile::AddLine | ( | const wxString & | str,
|  | wxTextFileType | type = `typeDefault`
| ) |  |

Adds a line to the end of file.

## ◆ Clear()

void wxTextFile::Clear | ( |  | ) |

Delete all lines from the file, set current line number to 0.

## ◆ Close()

bool wxTextFile::Close | ( |  | ) |

Closes the file and frees memory, "losing all changes".

Use Write() if you want to save them.

## ◆ Create() [1/2]

bool wxTextFile::Create | ( |  | ) |

Creates the file with the name which was given in the wxTextFile(const wxString&) constructor.

The array of file lines is initially empty.

It will fail if the file already exists, Open() should be used in this case.

## ◆ Create() [2/2]

bool wxTextFile::Create | ( | const wxString & | strFile | ) |

Creates the file with the given name.

The array of file lines is initially empty.

It will fail if the file already exists, Open() should be used in this case.

## ◆ Eof()

bool wxTextFile::Eof | ( |  | ) | const

Returns true if the current line is the last one.

## ◆ Exists()

bool wxTextFile::Exists | ( |  | ) | const

Return true if file exists - the name of the file should have been specified in the constructor before calling Exists().

## ◆ GetCurrentLine()

size_t wxTextFile::GetCurrentLine | ( |  | ) | const

Returns the current line: it has meaning only when you're using GetFirstLine()/GetNextLine() functions, it doesn't get updated when you're using "direct access" functions like GetLine().

GetFirstLine() and GetLastLine() also change the value of the current line, as well as GoToLine().

## ◆ GetEOL()

static const wxChar* wxTextFile::GetEOL | ( | wxTextFileType | type = `typeDefault` | ) |
| static

Get the line termination string corresponding to given constant.

typeDefault is the value defined during the compilation and corresponds to the native format of the platform, i.e. it will be `wxTextFileType_Dos` under Windows and `wxTextFileType_Unix` under Unix (including Mac OS X, the value `wxTextFileType_Mac` was only used for classic Mac OS versions).

## ◆ GetFirstLine()

wxString& wxTextFile::GetFirstLine | ( |  | ) |

This method together with GetNextLine() allows more "iterator-like" traversal of the list of lines, i.e.

you may write something like:

wxTextFile file;
...
for ( str = file.GetFirstLine(); !file.Eof(); str = file.GetNextLine() )
{
// do something with the current line in str
}
// do something with the last line in str
wxTextFile
The wxTextFile is a simple class which allows working with text files on line by line basis.
Definition: textfile.h:66
wxTextFile::GetNextLine
wxString & GetNextLine()
Gets the next line (see GetFirstLine() for the example).
wxTextFile::Eof
bool Eof() const
Returns true if the current line is the last one.
wxTextFile::GetFirstLine
wxString & GetFirstLine()
This method together with GetNextLine() allows more "iterator-like" traversal of the list of lines,...

## ◆ GetLastLine()

wxString& wxTextFile::GetLastLine | ( |  | ) |

Gets the last line of the file.

Together with GetPrevLine() it allows enumerating the lines in the file from the end to the beginning like this:

wxTextFile file;
...
for ( str = file.GetLastLine();
file.GetCurrentLine() > 0;
str = file.GetPrevLine() )
{
// do something with the current line in str
}
// do something with the first line in str
wxTextFile::GetPrevLine
wxString & GetPrevLine()
Gets the previous line in the file.
wxTextFile::GetLastLine
wxString & GetLastLine()
Gets the last line of the file.
wxTextFile::GetCurrentLine
size_t GetCurrentLine() const
Returns the current line: it has meaning only when you're using GetFirstLine()/GetNextLine() function...

## ◆ GetLine() [1/2]

wxString& wxTextFile::GetLine | ( | size_t | n | ) |

Retrieves the line number n from the file.

The returned line may be modified when non-const method is used but you shouldn't add line terminator at the end – this will be done by wxTextFile itself.

## ◆ GetLine() [2/2]

const wxString& wxTextFile::GetLine | ( | size_t | n | ) | const

## ◆ GetLineCount()

size_t wxTextFile::GetLineCount | ( |  | ) | const

Get the number of lines in the file.

## ◆ GetLineType()

wxTextFileType wxTextFile::GetLineType | ( | size_t | n | ) | const

Get the type of the line (see also wxTextFile::GetEOL).

## ◆ GetName()

const wxString& wxTextFile::GetName | ( |  | ) | const

Get the name of the file.

## ◆ GetNextLine()

wxString& wxTextFile::GetNextLine | ( |  | ) |

Gets the next line (see GetFirstLine() for the example).

## ◆ GetPrevLine()

wxString& wxTextFile::GetPrevLine | ( |  | ) |

Gets the previous line in the file.

## ◆ GoToLine()

void wxTextFile::GoToLine | ( | size_t | n | ) |

Changes the value returned by GetCurrentLine() and used by GetFirstLine() and GetNextLine().

## ◆ GuessType()

wxTextFileType wxTextFile::GuessType | ( |  | ) | const

Guess the type of file (which is supposed to be opened).

If sufficiently many lines of the file are in DOS/Unix/Mac format, the corresponding value will be returned. If the detection mechanism fails `wxTextFileType_None` is returned.

## ◆ InsertLine()

void wxTextFile::InsertLine | ( | const wxString & | str,
|  | size_t | n,
|  | wxTextFileType | type = `typeDefault`
| ) |  |

Insert a line before the line number n.

## ◆ IsOpened()

bool wxTextFile::IsOpened | ( |  | ) | const

Returns true if the file is currently opened.

## ◆ Open() [1/2]

bool wxTextFile::Open | ( | const wxMBConv & | conv = `wxConvAuto()` | ) |

Opens the file with the name which was given in the wxTextFile(const wxString&) constructor and also loads file in memory on success.

It will fail if the file does not exist, Create() should be used in this case.

The conv argument is only meaningful in Unicode build of wxWidgets when it is used to convert the file to wide character representation.

## ◆ Open() [2/2]

bool wxTextFile::Open | ( | const wxString & | strFile,
|  | const wxMBConv & | conv = `wxConvAuto()`
| ) |  |

Opens the file with the given name and also loads file in memory on success.

It will fail if the file does not exist, Create() should be used in this case.

The conv argument is only meaningful in Unicode build of wxWidgets when it is used to convert the file to wide character representation.

## ◆ operator[]()

wxString& wxTextFile::operator[] | ( | size_t | n | ) | const

The same as GetLine().

## ◆ RemoveLine()

void wxTextFile::RemoveLine | ( | size_t | n | ) |

Delete line number n from the file.

## ◆ Write()

bool wxTextFile::Write | ( | wxTextFileType | typeNew = `wxTextFileType_None`,
|  | const wxMBConv & | conv = `wxConvAuto()`
| ) |  |

Change the file on disk.

The typeNew parameter allows you to change the file format (default argument means "don't change type") and may be used to convert, for example, DOS files to Unix.

The conv argument is only meaningful in Unicode build of wxWidgets when it is used to convert all lines to multibyte representation before writing them to physical file.

Returns
  true if operation succeeded, false if it failed.

## Member Data Documentation

## ◆ typeDefault

const wxTextFileType wxTextFile::typeDefault
| static

Default type for current platform determined at compile time.